{%- from "debmirror/map.jinja" import client with context %}
{%- if client.enabled %}

debmirror_client_packages:
  pkg.installed:
  - names: {{ client.pkgs }}

{%- for mirror_name, opts in client.get("mirrors",{}).iteritems() %}

{%- if opts.get('enabled', True ) %}
debmirror_{{ mirror_name }}_present:
  debmirror.mirror_present:
    - name: {{ mirror_name }}
    - require:
      - debmirror_client_packages
  {%- if opts.get('cache_dir', '') != '' %}
      - debmirror_cache_dir_{{ mirror_name }}
      - debmirror_target_dir_{{ mirror_name }}
  {%- endif %}
  {%- if grains['saltversioninfo'][0] >= 2017 and grains['saltversioninfo'][1] >= 7 %}
    - retry:
        attempts: {{ opts.get('fetch_retry' , 1) }}
        until: True
        interval: 5
        splay: 2
  {%- endif %}

{%- if opts.get('cache_dir', '') != '' %}
debmirror_cache_dir_{{ mirror_name }}:
  file.directory:
    - name: '{{ opts.get('cache_dir') }}'
    - user: root
    - group: root
    - dir_mode: 755
    - makedirs: True
debmirror_target_dir_{{ mirror_name }}:
  file.directory:
    - name: '{{ opts.get('target_dir') }}'
    - user: root
    - group: root
    - dir_mode: 755
    - makedirs: True
debmirror_cache_readiness_{{ mirror_name }}:
  file.managed:
    - name: '{{ opts.get('cache_dir') }}/.ready'
    - replace: False
    - require:
      - debmirror_{{ mirror_name }}_present
{%- endif %}

{% endif %}

{%- endfor %}
{% endif %}
